unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Psock, NMHttp, OleCtrls, SHDocVw, ExtCtrls,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP;

type
  TForm1 = class(TForm)
    lbl1: TLabel;
    lbl2: TLabel;
    lbl3: TLabel;
    edtDir: TEdit;
    edtCP: TEdit;
    edtPais: TEdit;
    mmWeb: TMemo;
    Button1: TButton;
    nmhttp1: TNMHTTP;
    Button2: TButton;
    Panel1: TPanel;
    wb1: TWebBrowser;
    edt1: TEdit;
    Button3: TButton;
    idhttp1: TIdHTTP;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  STR_WEB = 'http://maps.google.com/maps/geo?q=';

implementation

{$R *.dfm}

uses
  ShellAPI, mshtml, urlMon;

procedure TForm1.Button1Click(Sender: TObject);
var
  str:string;
begin

  Str := STR_WEB + edtDir.Text + ',' + edtCP.Text + ',' + edtPais.Text;

//  ShellExecute(Handle,
//           'open',
//           PChar(Str),
//           nil,
//           nil,
//           SW_SHOW);

  nmhttp1.Get(Str);
  mmWeb.Text := NMHTTP1.Body
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  str:string;
begin

  Str := STR_WEB + edtDir.Text + ',' + edtCP.Text + ',' + edtPais.Text;
  edt1.Text := Str;
  wb1.Navigate(Str);

//  Sleep(5000);

//  mmWeb.Text := wb1.OleObject.Document.Body.InnerHTML
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  iall : IHTMLElement;
  Stream: TFileStream;
  Stream2: TStringStream;
  Str, Str2:string;

begin

  Str := STR_WEB + edtDir.Text + ',' + edtCP.Text + ',' + edtPais.Text;
  edt1.Text := Str;


  Stream := TFileStream.Create('r:\Datos.txt', fmCreate);
  Stream2 :=  TStringStream.Create(Str2);
  try
    idhttp1.Get(Str, Stream2);

    mmWeb.Lines.Text := Stream2.DataString;

  finally

    Stream.Free;
  end;

  Exit;

  if FileExists('r:\Datos.txt') then begin
    mmWeb.Lines.LoadFromFile('r:\Datos.txt');
  end
  else begin
    MessageDlg('NO existe...', mtWarning, [mbOK], 0);
  end;

    Exit;



  if Assigned(wb1.Document) then begin
    iall := (wb1.Document AS IHTMLDocument2).body;

    while iall.parentElement <> nil do begin
      iall := iall.parentElement;
    end;
    mmWeb.Text := iall.outerHTML;
  end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
  Str, Str2:string;
  res:Cardinal;
begin

  Str := STR_WEB + edtDir.Text + ',' + edtCP.Text + ',' + edtPais.Text;
  Str2 := 'r:\datos.txt';
  res := UrlDownloadToFile(nil, PChar(Str), PChar(Str2), 0, nil);

  if (res = 0) then begin
    mmWeb.Lines.LoadFromFile(Str2);
  end
  else begin
    MessageDlg('Erro al descargar datos', mtError, [mbOK], 0);
  end;

end;

end.
